% Contraintes du problme

function [c,ceq] = transfor_mono_con(input)


global input0 inputmax inputmin

% Mise  l'chelle %
for j=1 : size(input,2)
    input(1,j) = inputmin(1,j)+input(1,j)*(inputmax(1,j)-inputmin(1,j));
end


global c b kr rhocuivre alphacuivre l2spire muo a d n1 V2 V1 fp2 I2 
global Text Rcuivreair Rferair Rfercuivre l1spire Pfer f S1fil S2fil

% variables pour l'optimisation

a=input(1);
b=input(2);
c=input(3);
d=input(4);
n1=input(5);
S1fil=input(6);
S2fil=input(7);


% donnes et constantes

V2 = 24; % (V) tension secondaire
V1 = 230; % (V) tension primaire
f = 50; % (Hz) frquence
fp2 = 0.8; % facteur de puissance secondaire
I2 = 8; % (A) courant secondaire
Text = 40; % (C) temprature extrieur
q = 1; % (W/kg) qualit de tle
kr = 0.5; % Coefficient de remplissage des bobines du stator
h = 10; % (W/m2/K) coefficient de convexion de l'air
lambda = 0.15; % (W/m/K) coefficient de conduction de l'isolant
e_isol = 1E-3; % (m) paisseur de l'isolant
mvfer = 7800; % (kg/m3) masse volumique du fer
mvcuivre = 8800; % (kg/m3) masse volumique du cuivre
muo = 4*pi*1E-7; % permabilit du vide
rhocuivre = 1.72E-8; % Rsistivit du cuivre
alphacuivre = 3.8E-3; % variation de la rsistivit du cuivre

% Rsoudre 12 quations ayant chacune une inconnue

Bm = 1/4*V1*sqrt(2)/(n1*a*d*pi*f);
%S1fil = c*b*kr/(2*n1);
l1spire = 2*(d+2*a)+pi*c/2; 
Mfer = 4*a*d*(2*a+b+c)*mvfer;
Pfer = q*Mfer*f/50*(Bm/1)^2;
Rfercuivre = e_isol/(lambda*b*(4*a+2*d));
Sferair = 4*a*(4*a+b+2*c)+2*d*(6*a+b+2*c);
Rferair = 1/(h*Sferair);
Scuivreair = b*(4*a+2*pi*c);
Rcuivreair = 1/(h*Scuivreair);
l2spire = 2*(d+2*a)+pi*3*c/2;
l1 = 1/24*muo*n1^2*c*(16*a+8*d+3*pi*c)/b;

% Rsoudre 8 quations silmutalnes %

% r2 = rhocuivre*(1+alphacuivre*Tcuivre)*n2*l2spire/S2fil;
% X2 = 1/3*muo*n2^2*c*(4*a+2*d+pi*c)/b;
% n2 = n1*(V2+DV2)/V1;
% DV2 = (R2*fp2+X2*sin(acos(fp2)))*I2;
% Pj = R2*I2^2;
% Tcuivre = Text+Rcuivreair*(Rferair*Pfer+(Rferair+Rfercuivre)*Pj)/(Rcuivreair+Rferair+Rfercuivre);
% r1 = rhocuivre*(1+alphacuivre*Tcuivre)*n1*l1spire/S1fil;
% R2 = r2+(n2/n1)^2*r1;


% Donner les valeurs initiales pour rsoudre le systme de 16 quations: %



Tcuivre=40;
DV2=1;
n2 = n1*(V2+DV2)/V1;
r2 = rhocuivre*(1+alphacuivre*Tcuivre)*n2*l2spire/S2fil;
r1 = rhocuivre*(1+alphacuivre*Tcuivre)*n1*l1spire/S1fil;
R2 = r2+(n2/n1)^2*r1;
Pj = R2*I2^2;
X2 = 1/3*muo*n2^2*c*(4*a+2*d+pi*c)/b*2*pi*f;


x0=[r2 X2 n2 DV2 Pj Tcuivre r1 R2];

options=optimset('TolX',1e-6,'Display','off','LargeScale','off','Jacobian','on',...
    'NonlEqnAlgorithm','dogleg','MaxFunEvals',10000,'MaxIter',10000);
x=fsolve(@sys_equa_silmu,x0,options);

%S2fil=x(1);
r2=x(1);
X2=x(2);
n2=x(3);
DV2=x(4);
Pj=x(5);
Tcuivre=x(6);
r1=x(7);
R2=x(8);


% Continuer de rsoudre 6 quations ayant chacune inconnue

l2 = 1/24*muo*abs(n2)^2*c*(16*a+8*d+5*pi*c)/b;
Tfer = Text+Rferair*(Rcuivreair*Pj+(Rcuivreair+Rfercuivre)*Pfer)/(Rcuivreair+Rferair+Rfercuivre);
Lmu=muo*(1/(2.12E-4+((1-2.12E-4)*(Bm/1)^(2*7.358))/((Bm/1)^(2*7.358)+1.18E+6)))*n1^2*a*d/(2*a+b+c);
Mcuivre = mvcuivre*(n1*S1fil*l1spire+n2*S2fil*l2spire);
Mtotale = Mcuivre+Mfer;
ren = V2*I2*fp2/(V2*I2*fp2+Pfer+Pj);
P1 = Pfer+Pj+V2*I2*fp2;
Q1 = V1^2/(Lmu*2*pi*f)+X2*I2^2+V2*I2*sin(acos(fp2));
I1 = sqrt(P1^2+Q1^2)/V1;
I10 = sqrt((Pfer/V1)^2+(V1/(Lmu*2*pi*f))^2);

c_bis=c;

% Contraintes du problme

% rendement suprieur  80%
c(1) = 1-ren/0.8;

% Temprature du cuivre infrieure  120C
c(2) = Tcuivre/120-1;

% Temprature du fer infrieure  120C
c(3) = Tfer/100-1;

% Courant magntisant est infrieur  10% du courant primaire
c(4) = I10/(0.1*I1)-1;

% Chute de tension est infrieur  10% de la tension secondaire
c(5) = DV2/(0.1*V2)-1;

%Contraintes liant aus conducteurs
c(6) = 2*n1*S1fil/(b*c_bis*kr)-1;
% 
c(7) = 1-b*c_bis*kr/(2*n2*S2fil);

% Il n'y a pas de contrantes d'galit
ceq = [];


